import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import plugin from "@start/plugin";
export default ((outDirRelative, userOptions) => plugin('typescriptGenerate',
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* ({
    files,
    logFile
  }) {
    const path = yield import('path');
    const gracefulFs = yield import('graceful-fs');

    const _ref2 = yield import('makethen'),
          makethen = _ref2.default;

    const _ref3 = yield import('execa'),
          execa = _ref3.default;

    const _ref4 = yield import('dleet'),
          dleet = _ref4.default;

    const pWriteFile = makethen(gracefulFs.writeFile);
    const tscBinPath = path.resolve('node_modules/.bin/tsc');
    const spawnOptions = {
      stripEof: false,
      env: {
        FORCE_COLOR: '1'
      }
    };
    const rootConfigPath = path.resolve('tsconfig.json');
    return {
      files: yield Promise.all(files.map(
      /*#__PURE__*/
      function () {
        var _ref5 = _asyncToGenerator(function* (file) {
          const outDir = path.resolve(outDirRelative);
          const tempConfig = {
            extends: rootConfigPath,
            compilerOptions: _objectSpread({}, userOptions, {
              noEmit: false,
              emitDeclarationOnly: true,
              declaration: true,
              declarationDir: outDir
            }),
            // overwrite possible ones from the root config
            include: [file.path],
            files: [file.path] // 🙈 https://github.com/Microsoft/TypeScript/issues/12958

          };
          const tempConfigPath = path.join(path.dirname(file.path), `.${path.basename(file.path)}.tsconfig.json`);
          yield pWriteFile(tempConfigPath, JSON.stringify(tempConfig), 'utf8');

          try {
            yield execa(tscBinPath, ['--project', tempConfigPath], spawnOptions);
          } finally {
            yield dleet(tempConfigPath);
          }

          const dtsFilename = `${path.basename(file.path, '.ts')}.d.ts`;
          const dtsPath = path.resolve(outDir, dtsFilename);
          logFile(dtsPath);
          return {
            path: dtsPath,
            data: null,
            map: null
          };
        });

        return function (_x2) {
          return _ref5.apply(this, arguments);
        };
      }()))
    };
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}()));